VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Public Enum REGISTER_FUNCTIONS
    DllRegisterServer = 1
    DllUnRegisterServer = 2
End Enum
Public Sub SetDesktop(hwnd As Long)

    Desktop = hwnd

End Sub
Public Function GetDesktop() As Long

    If Desktop <> 0 Then
        GetDesktop = Desktop
    Else
        GetDesktop = GetDesktopWindow
    End If

End Function
Public Sub Execute(textline As String)
    
    While InStr(textline, ";")
        runCommand (left(textline, InStr(textline, ";") - 1))
        textline = right(textline, Len(textline) - InStr(textline, ";"))
    Wend
    runCommand textline

End Sub
Public Function LoadedPlugins() As IBasePlugin()

    Dim lp() As IBasePlugin
    Dim I As Long
    
    ReDim lp(UBound(Plugins))
    
    For I = 0 To UBound(Plugins)
        Set lp(I) = Plugins(I).oPlugin
    Next I
    
    LoadedPlugins = lp

End Function
Public Sub RegisterBang(provider As String, Name As String)

    Dim I As Integer
    
    ReDim Preserve Bangs(UBound(Bangs) + 1)
    Bangs(UBound(Bangs)).Name = Name
    Bangs(UBound(Bangs)).provider = provider
    If LCase(Name) = "!log" And UBound(Log) > 0 Then
        For I = 1 To UBound(Log)
            oServer.Execute "!log " & Log(I)
        Next
        ReDim Log(0)
    End If

End Sub
Public Function Version() As String

    Version = App.Major & "." & App.Minor

End Function
Public Sub SetKey(ByVal sSection As String, ByVal sKey As String, ByVal vntValue As Variant)

    oSettings.SetKey sSection, sKey, vntValue

End Sub
Public Function GetKey(ByVal sSection As String, ByVal sKey As String) As String
  
  GetKey = swapVirtual(oSettings.GetKey(sSection, sKey))
  
End Function
Public Function GetRawKey(ByVal sSection As String, ByVal sKey As String) As String
  
  GetRawKey = oSettings.GetKey(sSection, sKey)
  
End Function
Public Sub DelKey(ByVal sSection As String, vntKey As String)

    oSettings.DelKey sSection, vntKey

End Sub
Public Sub DelSection(ByVal sSection As String)

    oSettings.DelSection sSection

End Sub
Public Sub CreateSection(ByVal sSection As String)

    oSettings.CreateSection sSection

End Sub
Public Function GetSections() As String()

    GetSections = oSettings.GetSections
    
End Function
Public Function GetKeys(ByVal sSection As String) As String()

    GetKeys = oSettings.GetKeys(sSection)
    
End Function

Public Function evalNum(what As String) As Double

    Dim cEval As New Evaluator
    
    cEval.Expression = what
    evalNum = cEval.Result
    
'   Dim MyParser As New clsExpressionParser
'   evalNum = MyParser.ParseExpression(What)
    
End Function
Public Sub skin(what As Long)

'    frmDirectSkin.Wbocx1.AddIncludeList what

End Sub
Public Function evalBool(what As String) As Boolean

    Dim okBool() As String
    Dim Temp As String
    Dim I As Integer
    
    ReDim okBool(0)
    
    Temp = oSettings.GetKey("core", "bool1")
    If Temp = "" Then
        Temp = "1"
    Else
        While Temp <> ""
            ReDim Preserve okBool(UBound(okBool) + 1)
            okBool(UBound(okBool)) = Temp
            Temp = oSettings.GetKey("core", "bool" & UBound(okBool) + 1)
        Wend
    End If
    evalBool = False
    For I = 1 To UBound(okBool)
        If LCase(what) = LCase(okBool(I)) Then
            evalBool = True
        End If
    Next I

End Function
Public Sub transparant(hwnd As Long, color As Long)

    Dim nStyle As Long
    Dim r As RECT
    Dim cWidth As Long
    Dim cHeight As Long
    Dim hRgn As Long
    Dim Y As Long
    Dim X As Long
    Dim x0 As Long
    Dim tRgn As Long
    Dim wHDC As Long

    os.dwOSVersionInfoSize = Len(os)
    Call GetVersionEx(os)
    If (os.dwMajorVersion >= 5) Then
        nStyle = GetWindowLong(hwnd, GWL_EXSTYLE) Or WS_EX_LAYERED
        If SetWindowLong(hwnd, GWL_EXSTYLE, nStyle) Then
            Call SetLayeredWindowAttributes(hwnd, 0, LWA_OPAQUE, LWA_ALPHA)
        End If
        Call SetLayeredWindowAttributes(hwnd, color, 0, LWA_COLORKEY)
    Else
        GetWindowRect hwnd, r
        wHDC = GetDC(hwnd)

        cWidth = r.right - r.left
        cHeight = r.bottom - r.top
        hRgn = CreateRectRgn(0, 0, cWidth, cHeight)
        For Y = 0 To cHeight
            For X = 0 To cWidth
                While X <= cWidth And GetPixel(wHDC, X, Y) <> color
                    X = X + 1
                Wend
                x0 = X
                While X <= cWidth And GetPixel(wHDC, X, Y) = color
                    X = X + 1
                Wend
                If x0 < X Then
                    tRgn = CreateRectRgn(x0, Y, X, Y + 1)
                    CombineRgn hRgn, hRgn, tRgn, 4
                    DeleteObject tRgn
                End If
            Next X
        Next Y
        Call SetWindowRgn(hwnd, hRgn, True)
        DeleteObject hRgn
    End If
End Sub
Private Sub alpha(hwnd As Long, rate As Long)

    Dim ret As Long
    
    os.dwOSVersionInfoSize = Len(os)
    Call GetVersionEx(os)
    If (os.dwMajorVersion >= 5) Then
        ret = SetWindowLong(hwnd, GWL_EXSTYLE, WS_EX_LAYERED)
        ret = SetLayeredWindowAttributes(hwnd, 0, ((255 * rate) / 100), LWA_ALPHA)
    End If

End Sub
Public Sub stretch(hwnd As Long, bmp As String, ctop As Long, cbottom As Long, cleft As Long, cright As Long)

    Debug.Print "*** function data - hwnd=" & hwnd & " bmp=" & bmp & " ctop=" & ctop & " cbottom=" & cbottom & " cleft=" & cleft & " cright=" & cright
    
    Dim cHeight As Long
    Dim cWidth As Long
    Dim hDC As Long
    Dim wHDC As Long
    Dim bm As BITMAP
    Dim bSkinTiled As Boolean
    Dim hBmp As Long
    Dim r As RECT
    
    bSkinTiled = True
    GetWindowRect hwnd, r
    cWidth = r.right - r.left
    cHeight = r.bottom - r.top
    
    
    hBmp = LoadImage(App.hInstance, bmp, IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION Or LR_DEFAULTSIZE Or LR_LOADFROMFILE)
    If hBmp <> 0 Then
        wHDC = GetDC(hwnd)
        hDC = CreateCompatibleDC(wHDC)
        SelectObject hDC, hBmp
        GetObject hBmp, Len(bm), bm
        SetStretchBltMode hDC, 3
        
        Debug.Print "*** processing data wHDC=" & wHDC & " hdc=" & hDC & " hbmp=" & hBmp
    
        ' take the four corners to start with
        ' topleft
        BitBlt wHDC, 0, 0, cleft, ctop, hDC, 0, 0, SRCCOPY
    
        ' topright
        BitBlt wHDC, cWidth - cright, 0, cright, ctop, hDC, bm.bmWidth - cright, 0, SRCCOPY
    
        'bottomright
        BitBlt wHDC, cWidth - cright, cHeight - cbottom, cright, cbottom, hDC, bm.bmWidth - cright, bm.bmHeight - cbottom, SRCCOPY
    
        'bottomleft
        BitBlt wHDC, 0, cHeight - cbottom, cleft, cbottom, hDC, 0, bm.bmHeight - cbottom, SRCCOPY
    
        ' top
        StretchTileBlt wHDC, cleft, 0, cWidth - (cright + cleft), ctop, hDC, cleft, 0, bm.bmWidth - (cright + cleft), ctop, bSkinTiled, SRCCOPY
    
        ' right
        StretchTileBlt wHDC, cWidth - cright, ctop, cright, cHeight - (cbottom + ctop), hDC, bm.bmWidth - cright, ctop, cright, bm.bmHeight - (cbottom + ctop), bSkinTiled, SRCCOPY
    
        ' bottom
        StretchTileBlt wHDC, cleft, cHeight - cbottom, cWidth - (cright + cleft), cbottom, hDC, cleft, bm.bmHeight - cbottom, bm.bmWidth - (cright + cleft), cbottom, bSkinTiled, SRCCOPY
    
        ' left
        StretchTileBlt wHDC, 0, ctop, cleft, cHeight - (cbottom + ctop), hDC, 0, ctop, cleft, bm.bmHeight - (cbottom + ctop), bSkinTiled, SRCCOPY
    
        ' middle area
        StretchTileBlt wHDC, cleft, ctop, cWidth - (cright + cleft), cHeight - (cbottom + ctop), hDC, cleft, ctop, bm.bmWidth - (cright + cleft), bm.bmHeight - (cbottom + ctop), bSkinTiled, SRCCOPY
        
        DeleteDC hDC
    Else
        oServer.Execute "!log Error: file " & bmp & " wasn't found"
    End If

End Sub
Private Sub StretchTileBlt(ByVal hdcDst As Long, ByVal xDst As Long, ByVal yDst As Long, ByVal cxDst As Long, ByVal cyDst As Long, ByVal hdcSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal cxSrc As Long, ByVal cySrc As Long, ByVal bTiled As Boolean, ByVal dwRop As Long)

    Dim nWidth As Long
    Dim nHeight As Long
    Dim X As Long
    Dim Y As Long
    
    If bTiled Then

        nWidth = cxDst
        nHeight = cyDst

        For Y = 0 To nHeight - 1 Step cySrc

            cxDst = nWidth
            For X = 0 To nWidth - 1 Step cxSrc
                BitBlt hdcDst, xDst + X, yDst + Y, min(cxDst, cxSrc), min(cyDst, cySrc), hdcSrc, xSrc, ySrc, SRCCOPY
                cxDst = cxDst - cxSrc
            Next X
            cyDst = cyDst - cySrc
        
        Next Y
    
    Else
        StretchBlt hdcDst, xDst, yDst, cxDst, cyDst, hdcSrc, xSrc, ySrc, cxSrc, cySrc, SRCCOPY
    End If

End Sub
Private Function min(a As Long, b As Long) As Long

    If a >= b Then
        min = b
    Else
        min = a
    End If

End Function
' Load a plugin, added the registry code to this function to ease the loading
Public Function LoadPlugin(Name As String, Plugin As String) As Long

    Dim ret As Long
    Dim sClassID As String
    Dim oPlugin As core.IBasePlugin

    On Error GoTo loaderror
    
    sClassID = noPath(Plugin)
    If InStr(sClassID, ".") Then
        sClassID = left(sClassID, InStr(sClassID, ".") - 1)
    End If
    sClassID = sClassID & ".CPlugin"

    If (oPlugin Is Nothing) Then
        On Error Resume Next
loadit:
        Set oPlugin = CreateObject(sClassID)
        If ret > 0 Then
            If ret = 429 Then
                ret = oServer.RegisterComponent(Plugin, DllRegisterServer)
                If ret = 0 Then
                    GoTo loadit
                Else
                    Select Case ret
                    Case -1
                        oServer.Execute "!log Error while loading " & Name & ", File Could Not Be Loaded Into Memory Space"
                    Case -2
                        oServer.Execute "!log Error while loading " & Name & ", Not A Valid ActiveX Component"
                    Case -3
                        oServer.Execute "!log Error while loading " & Name & ", ActiveX Component Registration Failed"
                    End Select
                End If
            Else
                GoTo loaderror
            End If
        Else
            If Not (oPlugin Is Nothing) Then
                If Name = "" Then
                    Name = InputBox("Please name this instance", "Load plugin", "")
                    If Name = "" Then
                        Err.Number = -1
                        GoTo loaderror
                    End If
                End If
                ReDim Preserve Plugins(UBound(Plugins) + 1)
                Plugins(UBound(Plugins)).Name = Name
                Set Plugins(UBound(Plugins)).oPlugin = oPlugin
                Plugins(UBound(Plugins)).hwnd = Plugins(UBound(Plugins)).oPlugin.StartPlugin(Name)
                oServer.Execute "!log Loaded module " & Plugin & " as " & Name
            End If
        End If
        On Error GoTo loaderror
    End If
    Set oPlugin = Nothing
    Exit Function

loaderror:
    LoadPlugin = Err.Number

End Function
Public Sub UnloadPlugin(Name As String)

    Dim I As Long
    Dim j As Long
        
    I = 0
    While I < UBound(Plugins) And LCase(Plugins(I).Name) <> LCase(Name)
        I = I + 1
    Wend
    If LCase(Plugins(I).Name) = LCase(Name) Then
        Call Plugins(I).oPlugin.StopPlugin
        Set Plugins(I).oPlugin = Nothing
        For j = I To UBound(Plugins) - 1
            Plugins(j) = Plugins(j + 1)
        Next j
        ReDim Preserve Plugins(UBound(Plugins) - 1)
        oServer.Execute "!log Unloaded " & Name
    Else
        oServer.Execute "!log There is no module loaded with the name " & Name
    End If

End Sub
Public Sub UnloadPlugins()
    
    Dim I As Long
    
    For I = 1 To UBound(Plugins)
        If Not Plugins(I).oPlugin Is Nothing Then
            Call Plugins(I).oPlugin.StopPlugin
            Set Plugins(I).oPlugin = Nothing
        End If
    Next I
    ReDim Plugins(0)

End Sub
Public Function RegisterComponent(ByVal FileName As String, ByVal RegFunction As REGISTER_FUNCTIONS) As Long

    Dim lngLib As Long
    Dim lngProcAddress As Long
    Dim lpThreadID As Long
    Dim fSuccess As Long
    Dim dwExitCode As Long
    Dim hThread As Long
    
    If FileName = "" Then Exit Function
    
    lngLib = LoadLibraryRegister(FileName)
    If lngLib = 0 Then
        RegisterComponent = -1
        Exit Function
    End If
    
    Select Case RegFunction
    Case REGISTER_FUNCTIONS.DllRegisterServer
        lngProcAddress = GetProcAddressRegister(lngLib, "DllRegisterServer")
    Case REGISTER_FUNCTIONS.DllUnRegisterServer
        lngProcAddress = GetProcAddressRegister(lngLib, "DllUnregisterServer")
    Case Else
    End Select
    
    If lngProcAddress = 0 Then
       RegisterComponent = -2
       If lngLib Then Call FreeLibraryRegister(lngLib)
       Exit Function
    Else
       hThread = CreateThreadForRegister(ByVal 0, 0, ByVal lngProcAddress, ByVal 0, 0, lpThreadID)
       If hThread Then
            fSuccess = (WaitForSingleObject(hThread, 10000) = WAIT_OBJECT_0)
            If Not fSuccess Then
               Call GetExitCodeThread(hThread, dwExitCode)
               Call ExitThread(dwExitCode)
               RegisterComponent = -3
               If lngLib Then Call FreeLibraryRegister(lngLib)
               Exit Function
            Else
                If RegFunction = DllRegisterServer Then
                    RegisterComponent = 0
                ElseIf RegFunction = DllUnRegisterServer Then
                    RegisterComponent = 0
                End If
            End If
            Call CloseHandle(hThread)
            If lngLib Then Call FreeLibraryRegister(lngLib)
       End If
    End If

End Function
